#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* Utils include files                                            */
#include "../../src/defs.h"           /* general include file     */
/* MQSeries product include file                                  */
#include <cmqc.h>
/* MQSeries Services include files                                */
#include "mqsserr.h"

#include "mqss.h"

char *MQSSReasonString(MQLONG Reason)
{
  switch (Reason) {
     PRINTREAS(EMQM_REPLY_QUEUE_NOT_AUTH)
     PRINTREAS(EMQM_UNKNOWN_QUEUE_MGR)
     PRINTREAS(EMQM_DQH_STRUC_LEN_ERR1)
     PRINTREAS(EMQM_DQH_STRUC_LEN_ERR2)
     PRINTREAS(EMQM_UNKNOWN_REPLYTO_QMGR)
     PRINTREAS(EMQM_NOT_AUTH_BY_PAYMENT_OPTION)
     PRINTREAS(EMQM_MQXM_LENGTH_INCORRECT)
     PRINTREAS(EMQM_MQXM_TOTAL_LENGTH_INCORRECT)
     PRINTREAS(EMQM_RECEIVING_QMGR_EXPIRED)
     PRINTREAS(EMQM_NO_IE_ALIAS)
     PRINTREAS(EMQM_IE_NON_PAYMENT)
     PRINTREAS(EMQM_UNKNOWN_IE_RECIP)
     PRINTREAS(EMQM_ESO_MISMATCH)
     PRINTREAS(EMQM_MISSING_CTACCT)
     PRINTREAS(EMQM_MISSING_ORGACCT)
     PRINTREAS(EMQM_MISSING_CHROPT)
     PRINTREAS(EMQM_MISSING_PAYOPT)
	  /* feedback codes returned by validate_sender: */
     PRINTREAS(MQSSFB_CHANNEL_NOT_AUTH)
     PRINTREAS(MQSSFB_SENDING_QMGR_UNKNOWN)
     PRINTREAS(MQSSFB_SENDING_QMGR_EXPIRED)
     PRINTREAS(MQSSFB_SENDING_QMGR_CONFIG)
     /* feedback codes returned by validate_message: */
     PRINTREAS(MQSSFB_DEST_QMGR_UNKNOWN)
     PRINTREAS(MQSSFB_DEST_QMGR_EXPIRED)
     PRINTREAS(MQSSFB_DEST_QMGR_CONFIG)
     PRINTREAS(MQSSFB_DEST_Q_NOT_AUTH)
     PRINTREAS(MQSSFB_DEST_Q_CONFIG)

     PRINTREAS(MQSSFB_REPLY_QMGR_UNKNOWN)
     PRINTREAS(MQSSFB_REPLY_QMGR_EXPIRED)
     PRINTREAS(MQSSFB_REPLY_QMGR_CONFIG)
     PRINTREAS(MQSSFB_REPLY_Q_REQUIRED)
     PRINTREAS(MQSSFB_REPLY_Q_NOT_AUTH)
     PRINTREAS(MQSSFB_REPLY_Q_CONFIG)

     PRINTREAS(MQSSFB_IE_NO_ALIAS)
     PRINTREAS(MQSSFB_IE_REPLY_QMGR_CONFLICT)
     PRINTREAS(MQSSFB_IE_DEST_OPT_CONFLICT)
     PRINTREAS(MQSSFB_NOT_AUTH_BY_PAY_OPT)
     PRINTREAS(MQSSFB_SYSTEM_ERROR)
     PRINTREAS(MQSSFB_NO_SUCH_ALIAS)
     PRINTREAS(MQSSFB_INVALID_MQXQH)
    default:
		return("UNKNOWN Service-defined feedback code");
      break;
  }
  return("UNKNOWN Service-defined feedback code");
}